<template>
    <div class="home">
        <h3 class="home__welcome">Welcome to Jeff's Goods! Enjoy your shopping experience!</h3>
        <p class="home__instruction">Below you will find a list of items for purchase. Enter in the quantity you prefer and click the add to cart button.</p>
        <table>
            <thead>
                <tr>
                    <th>Item</th>
                    <th>Price</th>
                    <th>Quantity</th>
                    <th></th>
                </tr>
            </thead>
            <tbody>
                <template v-for="(item, index) in inventory">
                    <tr :key="index" :class="[!(index & 1) ? 'home__even-row' : '']">
                        <td>{{ item.name }}</td>
                        <td>{{ formatAsCurrency(item.price) }}</td>
                        <td>
                            <input type="number"
                                   v-model="item.qty"
                                   min="1"
                                   class="home__item-price-qty"
                                   @change="e => updateQty(e.target, item)" />
                        </td>
                        <td>
                            <input type="button" value="Add To Cart" @click="addItemToCart(item)" class="global__button-pointer" />
                        </td>
                    </tr>
                </template>
            </tbody>
        </table>
    </div>
</template>

<script>
    export default {
        name: 'Home',
        data: () => ({
            inventory: [
                {
                    name: "Book",
                    price: 12.49,
                    isTaxExempt: true,
                    isImported: false,
                    qty: 1,
                    tax: Number,
                    subTotal: Number,
                    importDuty: Number
                },
                {
                    name: "Music CD",
                    price: 14.99,
                    isTaxExempt: false,
                    isImported: false,
                    qty: 1,
                    tax: Number,
                    subTotal: Number,
                    importDuty: Number
                },
                {
                    name: "Chocolate bar",
                    price: .85,
                    isTaxExempt: true,
                    isImported: false,
                    qty: 1,
                    tax: Number,
                    subTotal: Number,
                    importDuty: Number
                },
                {
                    name: "Bottle of perfume",
                    price: 18.99,
                    isTaxExempt: false,
                    isImported: false,
                    qty: 1,
                    tax: Number,
                    subTotal: Number,
                    importDuty: Number
                },
                {
                    name: "Packet of headache pills",
                    price: 9.75,
                    isTaxExempt: true,
                    isImported: false,
                    qty: 1,
                    tax: Number,
                    subTotal: Number,
                    importDuty: Number
                },
                {
                    name: "Imported box of chocolates",
                    price: 11.85,
                    isTaxExempt: true,
                    isImported: true,
                    qty: 1,
                    tax: Number,
                    subTotal: Number,
                    importDuty: Number
                },
                {
                    name: "Imported bottle of perfume",
                    price: 27.99,
                    isTaxExempt: false,
                    isImported: true,
                    qty: 1,
                    tax: Number,
                    subTotal: Number,
                    importDuty: Number
                },
            ]
        }),
        methods: {
            addItemToCart(item) {
                this.$emit('add-item-to-cart', item);
            },
            updateQty(target, item) {
                let value = Number(target.value);
                item.qty = value;
            },
            formatAsCurrency(amount) {
                let formatedAmt = new Intl.NumberFormat("en-US", {
                    style: "currency",
                    currency: "USD",
                }).format(amount);

                return formatedAmt;
            }
        }
    };
</script>

<style scoped>
    .row {
        padding: 5px 0 5px 0;
    }

    .row:after {
        content: "";
        display: table;
        clear: both;
    }

    .column {
        float: left;
        width: 25%;
    }

    .home {
        padding: 1em;
    }

    .home__welcome {
        text-align: center;
    }

    .home__instruction {
        text-align: center;
        vertical-align: bottom;
    }

    .home__item-container {
        display: inline-block;
    }

    .home__item-name {
        text-align: right;
        float: left;
    }

    .home__item-price {
        text-align: center;
    }

    .home__item-price-qty {
        width: 3em;
    }

    .home__even-row {
        background-color: #bbb;
    }

    table {
        border-collapse: collapse;
    }

    table, td, tr {
        padding: 5px;
    }
</style>